
#
# A dumb dispatcher that does nothing
#

module Tomte::Workers
  class DumbDispatcher < Tomte::Worker

    worker :system => true, :do_not_registry => true

    def init(options = {})
      super
      log.warn "= Using the dumb dispatcher, supervision is disabled.".yellow

      director << :dispatcher_ready
    end

    def events
      receive do |filter|

        #
        # sign on the network
        #
        filter.when :sign_on do
          log.debug "- Dispatcher is signing-on to the network."
          director << :network_ready
        end

        #
        # sign off the network
        #
        filter.when :shutdown do
          log.debug "- Dispatcher been requested to sign-off the network and shut down."
          director << :dispatcher_exited
        end

        #
        # send an update message
        #
        filter.when :workers_update do

        end

        #
        # a new worker has been started
        #
        filter.when(T[:new_worker, Tomte::Worker]) do |_, worker|

        end

        #
        # wall messages
        #
        filter.when(T[:wall, Symbol, String, Hash]) do |_, severity, caption, options|
          log.warning '- This dispatcher does not support wall messages.'
        end
      end
    end
  end
end
